﻿// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Bot.Builder.Luis.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;

    /// <summary>
    /// LUIS Sentiment. Look at https://www.luis.ai/Help for more
    /// information.
    /// </summary>
    public partial class Sentiment
    {
        /// <summary>
        /// Initializes a new instance of the Sentiment class.
        /// </summary>
        public Sentiment() { }

        /// <summary>
        /// Initializes a new instance of the Sentiment class.
        /// </summary>
        public Sentiment(string label = default(string), double? score = default(double?))
        {
            Label = label;
            Score = score;
        }

        /// <summary>
        /// The text sentiment label detected by LUIS service in response to a query.
        /// </summary>
        [JsonProperty(PropertyName = "label")]
        public string Label { get; set; }

        /// <summary>
        /// The score for the sentiment label.
        /// </summary>
        [JsonProperty(PropertyName = "score")]
        public double? Score { get; set; }
    }
}